include: apply version filter on AutoLoad and AutoProbe arguments
[openwrt/staging/wigyori.git] / include / kernel.mk
1 #
2 # Copyright (C) 2006-2015 OpenWrt.org
3 #
4 # This is free software, licensed under the GNU General Public License v2.
5 # See /LICENSE for more information.
6 #
7
8 ifeq ($(__target_inc),)
9 include $(INCLUDE_DIR)/target.mk
10 endif
11
12 ifeq ($(DUMP),1)
13 KERNEL?=<KERNEL>
14 BOARD?=<BOARD>
15 LINUX_VERSION?=<LINUX_VERSION>
16 LINUX_VERMAGIC?=<LINUX_VERMAGIC>
17 else
18 ifeq ($(CONFIG_EXTERNAL_TOOLCHAIN),)
19 export GCC_HONOUR_COPTS=s
20 endif
21
22 LINUX_KMOD_SUFFIX=ko
23
24 ifneq (,$(findstring uml,$(BOARD)))
25 KERNEL_CC?=$(HOSTCC)
26 KERNEL_CROSS?=
27 else
28 KERNEL_CC?=$(TARGET_CC)
29 KERNEL_CROSS?=$(TARGET_CROSS)
30 endif
31
32 ifeq ($(TARGET_BUILD),1)
33 PATCH_DIR ?= ./patches$(if $(wildcard ./patches-$(KERNEL_PATCHVER)),-$(KERNEL_PATCHVER))
34 FILES_DIR ?= $(foreach dir,$(wildcard ./files ./files-$(KERNEL_PATCHVER)),"$(dir)")
35 endif
36 KERNEL_BUILD_DIR ?= $(BUILD_DIR)/linux-$(BOARD)$(if $(SUBTARGET),_$(SUBTARGET))
37 LINUX_DIR ?= $(KERNEL_BUILD_DIR)/linux-$(LINUX_VERSION)
38 LINUX_UAPI_DIR=uapi/
39 LINUX_VERMAGIC:=$(strip $(shell cat $(LINUX_DIR)/.vermagic 2>/dev/null))
40 LINUX_VERMAGIC:=$(if $(LINUX_VERMAGIC),$(LINUX_VERMAGIC),unknown)
41
42 LINUX_UNAME_VERSION:=$(if $(word 3,$(subst ., ,$(KERNEL_BASE))),$(KERNEL_BASE),$(KERNEL_BASE).0)
43 ifneq ($(findstring -rc,$(LINUX_VERSION)),)
44 LINUX_UNAME_VERSION:=$(LINUX_UNAME_VERSION)-$(strip $(lastword $(subst -, ,$(LINUX_VERSION))))
45 endif
46
47 MODULES_SUBDIR:=lib/modules/$(LINUX_UNAME_VERSION)
48 TARGET_MODULES_DIR := $(LINUX_TARGET_DIR)/$(MODULES_SUBDIR)
49
50 LINUX_KERNEL:=$(KERNEL_BUILD_DIR)/vmlinux
51
52 LINUX_SOURCE:=linux-$(LINUX_VERSION).tar.xz
53 TESTING:=$(if $(findstring -rc,$(LINUX_VERSION)),/testing,)
54 ifeq ($(call qstrip,$(CONFIG_EXTERNAL_KERNEL_TREE))$(call qstrip,$(CONFIG_KERNEL_GIT_CLONE_URI)),)
55 LINUX_SITE:=@KERNEL/linux/kernel/v3.x$(TESTING)
56 endif
57
58 ifneq ($(TARGET_BUILD),1)
59 PKG_BUILD_DIR ?= $(KERNEL_BUILD_DIR)/$(PKG_NAME)$(if $(PKG_VERSION),-$(PKG_VERSION))
60 endif
61 endif
62
63 ifneq (,$(findstring uml,$(BOARD)))
64 LINUX_KARCH=um
65 else ifneq (,$(findstring $(ARCH), aarch64 aarch64_be))
66 LINUX_KARCH := arm64
67 else ifneq (,$(findstring $(ARCH), armeb))
68 LINUX_KARCH := arm
69 else ifneq (,$(findstring $(ARCH), mipsel mips64 mips64el))
70 LINUX_KARCH := mips
71 else ifneq (,$(findstring $(ARCH), sh2 sh3 sh4))
72 LINUX_KARCH := sh
73 else ifneq (,$(findstring $(ARCH), i386 x86_64))
74 LINUX_KARCH := x86
75 else
76 LINUX_KARCH := $(ARCH)
77 endif
78
79 define KernelPackage/Defaults
80 FILES:=
81 AUTOLOAD:=
82 endef
83
84 define ModuleAutoLoad
85 $(SH_FUNC) \
86 export modules=; \
87 probe_module() { \
88 mods="$$$$$$$$1"; \
89 boot="$$$$$$$$2"; \
90 shift 2; \
91 for mod in $$$$$$$$($(SCRIPT_DIR)/metadata.pl version_filter $(KERNEL_PATCHVER) $$$$$$$$mods); do \
92 mkdir -p $(2)/etc/modules.d; \
93 echo "$$$$$$$$mod" >> $(2)/etc/modules.d/$(1); \
94 done; \
95 if [ -e $(2)/etc/modules.d/$(1) ]; then \
96 if [ "$$$$$$$$boot" = "1" ]; then \
97 mkdir -p $(2)/etc/modules-boot.d; \
98 ln -s ../modules.d/$(1) $(2)/etc/modules-boot.d/; \
99 fi; \
100 modules="$$$$$$$${modules:+$$$$$$$$modules}"; \
101 fi; \
102 }; \
103 add_module() { \
104 priority="$$$$$$$$1"; \
105 mods="$$$$$$$$2"; \
106 boot="$$$$$$$$3"; \
107 shift 3; \
108 for mod in $$$$$$$$($(SCRIPT_DIR)/metadata.pl version_filter $(KERNEL_PATCHVER) $$$$$$$$mods); do \
109 mkdir -p $(2)/etc/modules.d; \
110 echo "$$$$$$$$mod" >> $(2)/etc/modules.d/$$$$$$$$priority-$(1); \
111 done; \
112 if [ -e $(2)/etc/modules.d/$$$$$$$$priority-$(1) ]; then \
113 if [ "$$$$$$$$boot" = "1" ]; then \
114 mkdir -p $(2)/etc/modules-boot.d; \
115 ln -s ../modules.d/$$$$$$$$priority-$(1) $(2)/etc/modules-boot.d/; \
116 fi; \
117 modules="$$$$$$$${modules:+$$$$$$$$modules }$$$$$$$$priority-$(1)"; \
118 fi; \
119 }; \
120 $(3) \
121 if [ -n "$$$$$$$$modules" ]; then \
122 mkdir -p $(2)/etc/modules.d; \
123 mkdir -p $(2)/CONTROL; \
124 echo "#!/bin/sh" > $(2)/CONTROL/postinst; \
125 echo "[ -z \"\$$$$$$$$IPKG_INSTROOT\" ] || exit 0" >> $(2)/CONTROL/postinst; \
126 echo ". /lib/functions.sh" >> $(2)/CONTROL/postinst; \
127 echo "insert_modules $$$$$$$$modules" >> $(2)/CONTROL/postinst; \
128 chmod 0755 $(2)/CONTROL/postinst; \
129 fi
130 endef
131
132 ifeq ($(DUMP)$(TARGET_BUILD),)
133 -include $(LINUX_DIR)/.config
134 endif
135
136 define KernelPackage/depends
137 $(STAMP_BUILT): $(LINUX_DIR)/.config
138 define KernelPackage/depends
139 endef
140 endef
141
142 define KernelPackage
143 NAME:=$(1)
144 $(eval $(call Package/Default))
145 $(eval $(call KernelPackage/Defaults))
146 $(eval $(call KernelPackage/$(1)))
147 $(eval $(call KernelPackage/$(1)/$(BOARD)))
148
149 define Package/kmod-$(1)
150 TITLE:=$(TITLE)
151 SECTION:=kernel
152 CATEGORY:=Kernel modules
153 DESCRIPTION:=$(DESCRIPTION)
154 EXTRA_DEPENDS:=kernel (=$(LINUX_VERSION)-$(LINUX_RELEASE)-$(LINUX_VERMAGIC))
155 VERSION:=$(LINUX_VERSION)$(if $(PKG_VERSION),+$(PKG_VERSION))-$(if $(PKG_RELEASE),$(PKG_RELEASE),$(LINUX_RELEASE))
156 $(call KernelPackage/$(1))
157 $(call KernelPackage/$(1)/$(BOARD))
158 endef
159
160 ifdef KernelPackage/$(1)/description
161 define Package/kmod-$(1)/description
162 $(call KernelPackage/$(1)/description)
163 endef
164 endif
165
166 ifdef KernelPackage/$(1)/config
167 define Package/kmod-$(1)/config
168 $(call KernelPackage/$(1)/config)
169 endef
170 endif
171
172 $(call KernelPackage/depends)
173
174 ifneq ($(if $(filter-out %=y %=n %=m,$(KCONFIG)),$(filter m y,$(foreach c,$(filter-out %=y %=n %=m,$(KCONFIG)),$($(c)))),.),)
175 ifneq ($(if $(SDK),$(filter-out $(LINUX_DIR)/%.ko,$(FILES)),$(strip $(FILES))),)
176 define Package/kmod-$(1)/install
177 @for mod in $$$$$$$$($(SCRIPT_DIR)/metadata.pl version_filter $(KERNEL_PATCHVER) $$(FILES)); do \
178 if [ -e $$$$$$$$mod ]; then \
179 mkdir -p $$(1)/$(MODULES_SUBDIR) ; \
180 $(CP) -L $$$$$$$$mod $$(1)/$(MODULES_SUBDIR)/ ; \
181 elif [ -e "$(LINUX_DIR)/modules.builtin" ]; then \
182 if grep -q "$$$$$$$${mod##$(LINUX_DIR)/}" "$(LINUX_DIR)/modules.builtin"; then \
183 echo "NOTICE: module '$$$$$$$$mod' is built-in."; \
184 else \
185 echo "ERROR: module '$$$$$$$$mod' is missing." >&2; \
186 exit 1; \
187 fi; \
188 else \
189 echo "WARNING: module '$$$$$$$$mod' missing and modules.builtin not available, assuming built-in." >&2; \
190 fi; \
191 done;
192 $(call ModuleAutoLoad,$(1),$$(1),$(AUTOLOAD))
193 $(call KernelPackage/$(1)/install,$$(1))
194 endef
195 endif
196 $(if $(CONFIG_PACKAGE_kmod-$(1)),
197 else
198 compile: $(1)-disabled
199 $(1)-disabled:
200 @echo "WARNING: kmod-$(1) is not available in the kernel config - generating empty package" >&2
201
202 define Package/kmod-$(1)/install
203 true
204 endef
205 )
206 endif
207 $$(eval $$(call BuildPackage,kmod-$(1)))
208
209 $$(IPKG_kmod-$(1)): $$(wildcard $$(FILES))
210 endef
211
212 define AutoLoad
213 add_module "$(1)" "$(2)" "$(3)";
214 endef
215
216 define AutoProbe
217 probe_module "$(1)" "$(2)";
218 endef
219
220 version_field=$(if $(word $(1),$(2)),$(word $(1),$(2)),0)
221 kernel_version_merge=$$(( ($(call version_field,1,$(1)) << 24) + ($(call version_field,2,$(1)) << 16) + ($(call version_field,3,$(1)) << 8) + $(call version_field,4,$(1)) ))
222
223 ifdef DUMP
224 kernel_version_cmp=
225 else
226 kernel_version_cmp=$(shell [ $(call kernel_version_merge,$(call split_version,$(2))) $(1) $(call kernel_version_merge,$(call split_version,$(3))) ] && echo 1 )
227 endif
228
229 CompareKernelPatchVer=$(if $(call kernel_version_cmp,-$(2),$(1),$(3)),1,0)
230
231 kernel_patchver_gt=$(call kernel_version_cmp,-gt,$(KERNEL_PATCHVER),$(1))
232 kernel_patchver_ge=$(call kernel_version_cmp,-ge,$(KERNEL_PATCHVER),$(1))
233 kernel_patchver_eq=$(call kernel_version_cmp,-eq,$(KERNEL_PATCHVER),$(1))
234 kernel_patchver_le=$(call kernel_version_cmp,-le,$(KERNEL_PATCHVER),$(1))
235 kernel_patchver_lt=$(call kernel_version_cmp,-lt,$(KERNEL_PATCHVER),$(1))
236